/* Text I/O test */

#include "TextTest.h"

#include "bfstream.h"

#include <iostream>
#include <string>

using namespace std;

///////////////////

void Output_Text()
{
	int	index;

	cout <<	"Output Text" << endl;
	cout << "------------" << endl;

	bofstream os("text.txt");					// output in text mode
	//	bofstream os("text.txt", ios::binary);		// output in binary mode

	if (!os)
	{
		cout << "*******************************************************" << endl;
		cout << "******************* Error creating file****************" << endl;
		cout << "*******************************************************" << endl;
	}

	int		i	= 123;
	float	f	= 456.78f;
	double	d	= 9101.123456678;

	os << setprecision(10) << setw(10); 

	os << i << _ << f << t_ << d << endl;				// element seperated by a space and then a tab

	cout << i << " " << f << " " << d << endl;

	float	f_a[5]	= {		28.01f, 27.01f, 26.01f, 25.01f, 24.01f	};

	for (index = 0; index < 5; ++index)					// every element on a newline
		os << f_a[index] << endl;

	for (index = 0; index < 5; ++index)
		cout << f_a[index] << " ";
	cout << endl;

	os		<< " This is a string" << ends;				// a string. ends will insert a newline automatically
	cout	<< " This is a string" << endl;

	os		<< "This is a combined string";
	os		<< '\n';
	os		<< "seperated by a newline" << ends;		// combined string. ends will insert a newline automatically

	cout	<< "This is a combined string";
	cout	<< '\n';
	cout	<< "seperated by a newline" << endl;

	os		<< 'Z' << endl;				// output a char - remember the need for the endl because the next write requires to start on a newline
	cout	<< 'Z' << endl;

	double d_a[5]	= {		-10.23f, -11.23f, -12.23f, -13.23f, -14.23f	};

	os.write(d_a, sizeof(double) * 5);					// write a block of memory. A newline will be inserted automatically

	for (index = 0;  index < 5; ++index)
		cout << d_a[index] << " ";
	cout << endl;

	float f_arr[5]	= {		99.1f, 99.2f, 99.3f, 99.4f, 99.5f	};

	os.write(f_arr, sizeof(float) * 5);					// write another block. A newline will be inserted automatically

	for (index = 0;  index < 5; ++index)
		cout << f_arr[index] << " ";
	cout << endl;

	os << 'A' << 'B' << 'C';							// output 3 chars without spacing

	cout << 'A' << " " << 'B' << " " << 'C' << endl;

	if (!os)
	{
		cout << "*******************************************************" << endl;
		cout << "******************* Error creating file****************" << endl;
		cout << "*******************************************************" << endl;
	}
}

////////

void Input_Text()
{
	int index;

	cout << "Text Input" << endl;
	cout << "-----------" << endl;

	bifstream is("text.txt");				// input in text mode
	//	bifstream is("text.txt", ios::binary);	// input in binary mode

	if (!is)
	{
		cout << "*******************************************************" << endl;
		cout << "******************* Error reading file ****************" << endl;
		cout << "*******************************************************" << endl;
	}

	int		i	= 0;
	float	f	= 0;
	double	d	= 0;

	is >> i >> f >> d;						// read in 3 elements

	cout << i << " " << f << " " << d << endl;

	float f_a[5]	= { 0.0f };

	for (index = 0; index < 5; ++index)		// read in another 5 elements
		is >> f_a[index];

	for (index = 0; index < 5; ++index)
		cout << f_a[index] << " ";
	cout << endl;

	string s1, s2;

	is >> s1 >> s2;							// read in two strings

	cout << s1.c_str() << endl;
	cout << s2.c_str() << endl;

	char c;

	is >> c;								// read in a char

	cout << c << endl;

	double d_a[5];

	is.read(d_a, sizeof(double) * 5);		// read a block of doubles

	for (index = 0; index < 5; ++index)
		cout << d_a[index] << " ";
	cout << endl;

	float f_arr[5];

	is.read(f_arr, sizeof(float) * 5);			// read in a block of floats

	for (index = 0; index < 5; ++index)
		cout << f_arr[index] << " ";
	cout << endl;

	char ch1, ch2, ch3;

	is >> ch1 >> ch2 >> ch3;					// read int 3 chars

	cout << ch1 << " " << ch2 << " " << ch3 << endl;

	if (!is)
	{
		cout << "*******************************************************" << endl;
		cout << "******************* Error reading file ****************" << endl;
		cout << "*******************************************************" << endl;
	}
}